/* ==================================
     zmc3-extended MML
   ================================== */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <time.h>
#include "parsesub.h"
#include "makezmd1.h"
#include "bracket.h"
#include "prog.h"

#include "structs.h"
#include "structs2.h"


UBYTE *makeZmdAutoPanpotSwitch(UBYTE *zms, TRKINF *trkinf, const BYTE target[]);
UBYTE *makeZmdAutoPanpot(UBYTE *zms, TRKINF *trkinf,
							COMMONINF *comfinf, const BYTE target[]);
UBYTE *makeZmdSc88ProEfxSwitch(
		UBYTE *zms,TRKCHINF *trkdata, const BYTE target[], int mode);

UBYTE *getIdIfCh(UBYTE *zms, TRKCHINF *trkdata, int Trk, int idflag,
					DWORD *id, DWORD *ifno, DWORD *ch);
UBYTE *macroExclusive88Pro(UBYTE *zms, BYTE e[], const DWORD elen,
							const int pos, const char *cmnt,
							int idflag, int roland, TRKCHINF *trkdata,
							const BYTE target[]);
int channel2Block(int ch);


extern DWORD line;
extern char *linebuf;
extern LINEDATA *ld;


enum {
	NOUSE	= 0x00,
	NRPN	= 0x10, EXC, SPECIAL,
	ALL		= 0x20, XG, MU90, GS,
	PAN		= 0x80
};

#ifdef Aa
NORMALPARA
{
	NRPN,ALL,	0x01, 0x08, NOUSE,	"vibrato_rate",
	NRPN,ALL,	0x01, 0x09, NOUSE,	"vibrato_depth",
	NRPN,ALL,	0x01, 0x0A, NOUSE,	"vibrato_delay",
	NRPN,ALL,	0x01, 0x20, NOUSE,	"cof",
	NRPN,ALL,	0x01, 0x21, NOUSE,	"res",
	NRPN,ALL,	0x01, 0x63, NOUSE,	"attack",
	NRPN,ALL,	0x01, 0x64, NOUSE,	"decay",
	NRPN,ALL,	0x01, 0x66, NOUSE,	"release",
}

DRUMPARA
{
	SPECIAL,ALL,NOUSE,NOUSE,NOUSE,	"note",
	NRPN,XG,	0x14, 0x00, NOUSE,	"lpf_cof",
	NRPN,XG,	0x15, 0x00, NOUSE,	"lpr_res",
	NRPN,XG,	0x16, 0x00, NOUSE,	"EG Attack Rate",
	NRPN,XG,	0x17, 0x00, NOUSE,	"EG Decay Rate",

	NRPN,ALL,	0x18, 0x00, NOUSE,	"pitch_course",
	NRPN,XG,	0x19, 0x00, NOUSE,	"pitch_fine",
	NRPN,ALL,	0x1A, 0x00, NOUSE,	"tva",
	NRPN,ALL,	0x1A, 0x00, NOUSE,	"level",
	NRPN,ALL,	0x1C, 0x00, NOUSE,	PAN,	"panpot",
/*	EXC, GS,	0x41, 0x04, NOUSE,	PAN,	"panpot", */
	NRPN,ALL,	0x1D, 0x00, NOUSE,			"reverb",
	NRPN,ALL,	0x1E, 0x00, NOUSE,			"chorus",
	NRPN,ALL,	0x1F, 0x00, NOUSE,			"delay",
	NRPN,ALL,	0x1F, 0x00, NOUSE,			"variation",

	NRPN,MU90,	0x24, 0x00, NOUSE,			"hpf_cof",
	NRPN,MU90,	0x30, 0x00, NOUSE,			"EQ_Bass Gain",
	NRPN,MU90,	0x31, 0x00, NOUSE,			"EQ Treble Gain",
	NRPN,MU90,	0x34, 0x00, NOUSE,			"EQ Bass Frequency",
	NRPN,MU90,	0x35, 0x00, NOUSE,			"EQ Treble Frequency"

/* GS: ʏhZbgłȂA[Uh̏ꍇA0x410x21 */
	EXC, GS,	0x41, 0x03, NOUSE,	"exc",
	EXC, GS,	0x41, 0x07, NOUSE,	"noteoff",
}

/*
	Drums NRPN paramters in XG

@14 Drum Low Pass Filter Cut Off Frequency			/XG
  15 Drum Low Pass Filte Resonance
  16 Drum EG Attack Rate
  17 Drum EG Decay Rate

  18 Drum Instrument Pitch Course
  19 Drum Instrument Pitch Fine
  1A Drum Instrument Level
  1C Drum Instrument Panpot
  1D Drum Instrument Reverb Send Level
  1E Drum Instrument Chorus Send Level
  1F Drum Instrument Variation Send Level
  24 Drum High Pass Filetr Cut Off Frequency		/MU90 or later
  30 Drum EQ Bass Gain								/
  31 Drum EQ Treble Gain
  34 Drum EQ Bass Frequency
  35 Drum EQ Treble Frequency

@ꂾ܂i24Hȍ~MU90ȏjB
*/
#endif




extern DWORD line;
extern char *linebuf;
extern LINEDATA *ld;





















UBYTE *makeZmdAutoPanpotSwitch(UBYTE *zms, TRKINF *trkinf, const BYTE target[])
{
	int trk, err;
	DWORD para;
	const char *p[] = {"off", "on", NULL};

	zms = getnum4(zms,&para,&err, p, 0);
	if (!err) {
		for (trk = 0; target[trk] >= 0; trk++) {
			const int Trk = target[trk];
			trkinf[Trk].autopansw = para;
		}
	} else {
		zmserror("[AUTO_PANPOT.SWITCH] require its parameter.",linebuf,zms,4,1);
	}
	return zms;
}


UBYTE *makeZmdAutoPanpot(UBYTE *zms, TRKINF *trkinf,
							COMMONINF *cominf, const BYTE target[])
{
	int trk;
	DWORD line_ = line;
	UBYTE *linebuf_ = linebuf;
	UBYTE *zms_ = zms;
	LINEDATA *ld_ = ld;


	for (trk = 0; target[trk] >= 0; trk++) {
		const int Trk = target[trk];
		/* const int octbak = trkinf[Trk].octave; */
		const char *p[] = {"off", "on", NULL};
		DWORD sw = 1;
		int paras, err;
		BYTE lastnote, lastpan;

		linebuf = linebuf_;
		line = line_;
		ld = ld_;

		zms = getnum4(zms_,&sw,&err, p, 0);
		trkinf[Trk].autopansw = sw;

		zms = skipSpcCr(zms);
		if (*zms == ',') {
			zms++;
		}
		if (*zms != ']') {

			for (paras = 0; ; paras++) {
				int ofst;
				BYTE rel, note;
				DWORD pan;

				linebuf = linebuf_;
				line = line;
				ld = ld_;

				zms = getZmsNoteSub(zms, trkinf, cominf, Trk, &note);

				zms = skipSpcCr(zms);
				if (*zms == ',') {
					zms++;
				}

				zms = getPanpotValue(zms, 2, &rel, &pan, &ofst);
				if (rel != 0) {
					if (paras == 0) {
						zmserror("[auto_panpot] can't handle relative value with the 1st note parameter.",linebuf,zms,0,1);
					} else {
						pan += lastpan;
					}
				}

				if (paras == 0) {	/* wӏ荶PAN𖄂߂ */
					int i;
					for (i = 0; i < note; i++) {	/* ŏ̒n_荶͑S */
						trkinf[Trk].autopan[i] = pan;
					}
				} else {							/* ȍ~͂PȐ */
					int i;
					DWORD deltapan = (pan - lastpan) * 0x100 / (note - lastnote);
					DWORD nowpan = lastpan * 0x100;
					for (i = lastnote + 1; i < note; i++) {
						trkinf[Trk].autopan[i] = nowpan / 0x100;
						nowpan += deltapan;
					}
					trkinf[Trk].autopan[note] = pan;
				}
				lastpan = pan;
				lastnote = note;

				zms = skipSpcCr(zms);
				if (*zms != ',') {
					int i;
					for (i = note + 1; i < 128; i++) {	/* Ō̒n_E͑S */
						trkinf[Trk].autopan[i] = pan;
					}
					break;
				} else {
					zms++;
				}
			}
		}
	}
	return zms;
}




#ifdef AAAA
/* ====================================================================*/
/* SC-88 Pro MML */
/* ====================================================================*/

UBYTE *makeZmdSc88ProEfxSwitch(
		UBYTE *zms,TRKCHINF *trkdata, const BYTE target[], int mode)
/*
.sc88Pro_efx_on id,if {ch}
.sc88Pro_efx_off id,if {ch}
.sc88_efx_bypass id,if {ch}
[sc88Pro_efx_on id,if {ch}]
[sc88Pro_efx_off id,if {ch}]
[sc88_efx_bypass id,if {ch}]

40 4x 22 00 / 0:BYPASS(off) / 01:EFX(on)
*/
/* mode: 0=off(bypass), 1=on(efx) */
{
	const DWORD elen = 10;
	BYTE e[10] = { 0xf0,0x41,0x10,0x42,0x12,0x40,0x40,0x22,0x00,0x00 };
	int pos = 6;
	const int rolandchecksum = 1;
	const int idflag = 1;

	e[9] = mode;
	zms = macroExclusive88Pro(zms, e, elen, pos,
								"SC88PRO_EFX_SWITCH",
								idflag, rolandchecksum, trkdata, target);

	zmserror(".sc88pro_efx_* can use only for zmc3.",linebuf,zms,4,1);


	return zms;
}






/* ====================================================================*/
/* useful subroutines */
/* ====================================================================*/

UBYTE *getIdIfCh(UBYTE *zms, TRKCHINF *trkdata, int Trk, int idflag,
					DWORD *id, DWORD *ifno, DWORD *ch)
{
	int err;

	zms = getIdIf(zms, idflag, id, ifno);

	zms = skipSpc(zms);
	if (*zms == '{') {
		zms = getnum2(++zms,ch,&err);
		if (err == -1) {
			*ch = (Trk)? trkdata[Trk].ch : -1;
		} else if (err > 0) {
			zmserror("channel number error.",linebuf,zms,0,1);
		}
		zms = skipSpc(zms);
		if (*zms != '}') {
			zmserror("SYNTAX ERROR.",linebuf,zms,0,1);
		}
	}

	return zms;
}


UBYTE *macroExclusive88Pro(UBYTE *zms, BYTE e[], const DWORD elen,
							const int pos, const char *cmnt,
							int idflag, int roland, TRKCHINF *trkdata,
							const BYTE target[])
{
	int trk;

	for (trk = 0; target[trk] >= 0; trk++) {
		int err, Trk = target[trk];
		DWORD id, ifno = 0xFF, ch;

		zms = getIdIfCh(zms, trkdata, Trk, idflag, &id, &ifno, &ch);
		if (ch == -1) {
			zmserror("channel number is required.",linebuf,zms,0,1);
		}
		e[2] = id;

		e[pos] |= channel2Block(ch);

		macroExclusiveMain(e, elen, cmnt, ifno, roland, trkdata, Trk);
	}
	return zms;
}


int channel2Block(int ch)	/* convert from channel# to block# */
{
	if (ch == 10) {
		ch = 0;
	} else if (ch > 10) {
		ch--;
	}

	return (ch & 0xF);
}
#endif
