/* ================
       put usage
   ================ */

#include <stdio.h>
#include <stdlib.h>

#include "etc.h"

void help(int exitcode,int helpmode);


void help(int exitcode,int helpmode)
{
	const char *helpmes[] = {
#ifdef UNIXY_OS
		"usage: zmc3 [-switches] source[.zms] [-o destination[.zmd]] [-e errfile]",
#else
		"usage: zmc3 [-switches] source[.ZMS] [-o destination[.ZMD]] [-e errfile]",
#endif
#if WARNLVL == 1
		"switch: -Wnum        warning level(1=none(default), 2=as V2(traditional),",
		"                                   3=as V3, 4=most strict)",
#elif WARNLVL == 2
		"switch: -Wnum        warning level(1=none, 2=as V2(traditional,default),",
		"                                   3=as V3(default), 4=most strict)",
#elif WARNLVL == 3
		"switch: -Wnum        warning level(1=none, 2=as V2(traditional),",
		"                                   3=as V3(default), 4=most strict)",
#else
		"switch: -Wnum        warning level(1=none, 2=as V2(traditional),",
		"                                   3=as V3, 4=most strict(default))",
#endif
		"        -Rnum        warning level(regard as error; stop compiling immediately)",
		"        -Znum        compatible level(1=normal(default),",
		"                                      3=ZMUSIC.X -c)",
		"        -            use standard input (you must use it with -c or -o)",
		"        -c           use standard output",
		"        -e errfile   redirect the stderr to the specified file",
		"        -l           change warning/error message pattern",
		"        -t           show the total steps in the tracks",
		"        -o destname  specify ZMD filename",
		"        -h           show this help messages",
		"",
		"Some FM/ADPCM MMLs will be ignored. (however to be supported)",
		/* "FM/ADPCM MMLs will be ignored.", */

/*
		"",
		"If you want to show TIPS, type; zmc3 -h1 | more",
*/
		NULL,

		"zmc3 tips",
		"  When warning level is 1 or 2, zmc2-extended-MML will be warned.",
		"e.g. YAMAHA-exclusive, portament MML at begining of line",
		"",
		"You can get the latest version at http://www2s.biglobe.ne.jp/~yyagi/",
		NULL
	};
	char **str = (char**)helpmes;

	if (helpmode) {
		while (*str++ != NULL)
			;
	}
	do {
		fputs(*str++,stderr);
		fputs("\n",stderr);
	} while (*str != NULL);

	terminateProgram(exitcode);
}
