/* ========================================
	making hash table for the program name
   ======================================== */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "config.h"
#include "etc.h"
#include "hashsub.h"



int main(int argc, char **argv)
{
	char	tmp[128];
	DWORD	totalprog = 0;
	DWORD	used = 0;
	DWORD	depth = 0;
	UWORD	max = 0, min = HASHTABLESIZE;
	int		i;
	int		module = 0;
	PROGHASH	**tbl;

	if (argc != 2) {
		fprintf(stderr,"Usage: makehash target(gs/xg)\ne.g.   makehash gs\n");
		terminateProgram(FILENOTFOUND);
	}
	if (!strcmp(argv[1], "gs")) {
		module = 1;
	} else if (!strcmp(argv[1], "xg")) {
		module = 2;
	}

	initMemMaster();
	initHash(&tbl);


	while (!feof(stdin)) {
		int		pc,msb,lsb;
		char	prg[128];
		WORD	hash;
		DWORD	depth2 = 0;

		fgets(tmp, 128, stdin);
		sscanf(tmp, "%d,%d,%d,%s", &pc, &msb, &lsb, prg);

		if (module != 1 || msb != 126) {		/* GS: CM-64 tone is ignored */
			hash = calcHash2(tbl, prg, &depth2);
			if (hash >= 0) {
				used += depth2;
				setHashTable(tbl, hash, prg, pc, msb, lsb);

				if (depth2 > depth) {
					depth = depth2;
				}
				if (hash > max)	max = hash;
				if (hash < min)	min = hash;
				totalprog++;
			}
		}
	}


/*	printf("const PROGHASH gshashtbl[] = {\n");*/
	for (i = 0; i < HASHTABLESIZE; i++) {
		if (tbl[i] != NULL) {
			printf("\t0x%.4x,%d,%d,%d,\"%s\",\n", 
			i, tbl[i]->pc, tbl[i]->msb, tbl[i]->lsb, tbl[i]->progname);
#ifdef A
		} else {
			printf("\t0,-1,-1,NULL,\n");
#endif
		}
	}
	freeHash(tbl);
/*	printf("\t-1,-1,-1,NULL\n}\n"); */
	printf("/*\nTotal Programs: %d\n", totalprog);
	printf("Collision occurred: %d\n", used);
	printf("Collision max depth: %d\n", depth);
	printf("max/min=%.4x/%.4x\n*/\n",max,min);

	return EXIT_SUCCESS;
}
