/* ======================
     Change Program No.
   ====================== */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "etc.h"
#include "parsesub.h"
#include "68lib.h"
#include "makezmd2.h"
#include "makezmd3.h"
#include "hashsub.h"

#include "structs.h"
#include "structs2.h"
void createCashTable(void);
void releaseCashTable(void);
UBYTE *makeZmdProgramChange(UBYTE *zms, TRKCHINF *trkdata, const BYTE target[]);
UBYTE *makeZmdProgramBankChange(UBYTE *zms, TRKCHINF *trkdata, const BYTE target[]);
UBYTE *makeZmdProgramSplitSwitch(UBYTE *zms, TRKCHINF *trkdata, const BYTE target[]);
UBYTE *makeZmdProgramSplit(UBYTE *zms, TRKCHINF *trkdata, TRKINF *trkinf,
							COMMONINF *cominf, const BYTE target[]);
UBYTE *getZmsNoteSub(UBYTE *zms, TRKINF *trkinf, COMMONINF *cominf, const int Trk, BYTE *note);
char *cutChar(char *str, char *cut);
int stringReplace(char *str, const char *s1, const char *s2);


extern DWORD line;
extern char *linebuf;
extern LINEDATA *ld;


PROGHASH hashraw[] = {
#include "gsprog.hh"
	0, 0,-1,-1,NULL,
#include "xgprog.hh"
	0, 0,-1,-1,NULL
};
static PROGHASH ***hashtbl;
static int hashflg = 0;

enum	{	GS = 0, XG };




void createCashTable()
{
	if (!hashflg) {
		int j, k = 0;
		hashflg = 1;
		hashtbl = (PROGHASH***)emalloc(sizeof(PROGHASH**) * 2, "Hash table");
		for (j = 0; j < 2; j++) {
			int i;
			hashtbl[j] = (PROGHASH**)emalloc(sizeof(PROGHASH*) * (HASHTABLESIZE + 1),
						"Hash table");
			for (i = 0; i < HASHTABLESIZE - 1; i++) {
				hashtbl[j][i] = NULL;
			}
			while (hashraw[k].msb != -1 || hashraw[k].lsb != -1 ||
				hashraw[k].progname != NULL) {
				hashtbl[j][hashraw[k].hash] = &hashraw[k];
				k++;
			}
			k++;
		}
	}
}

void releaseCashTable()
{
	if (hashflg) {
		int j;
		for ( j = 0; j < 2; j++) {
			efree(hashtbl[j], "Hash table");
		}
		efree(hashtbl, "Hash table");
		hashflg = 0;
	}
}




UBYTE *makeZmdProgramChange(UBYTE *zms, TRKCHINF *trkdata, const BYTE target[])
{
	int trk, err, cmd = 0;
	DWORD tone, b1, b2 = 0;
	int mmlmode = 0;
	int module = -1;	/* 0: GS 1: XG */

	if (*(zms - 1) != '@') {
		mmlmode = 1;		/* not '@' but [program ... */
	}

	{
		UBYTE *p = zms;
		if (mmlmode) {
			while (*p != ']' && *p != 0xFF && *p != nativeCR) {
				if (*p == '\"') {
					mmlmode |= 2;		/* [program "piano1"] */
					break;
				} else if (*p == '\'') {
					mmlmode |= 4;		/* [program 'piano1'] */
					break;
				} else if (isalpha(*p)) {
					mmlmode |= 8;		/* [program piano1] */
				}
				p++;
			}
		}
	}
/* fprintf(stderr,"[mmlmode=%d]\n",mmlmode); */
	zms = getnum2(zms,&tone,&err);
	if (err || mmlmode > 2) {
		int		p = 1, offset = 0;
		char	*progname;
		BYTE	/* realmsb = -1, */ reallsb = -1;
		WORD	hash, hash2;
		PROGHASH *tmp;
		UBYTE	endchar;

		if (*zms != '\"' && *zms != '\'' && !(mmlmode & 8)) {
			zmserror("`@'(program set) must be followed to its parameter.",linebuf,zms,0,1);
		}

		/* @"..." || @'...'*/
		endchar = (mmlmode & 8)? ']' : *zms;
		while (*(zms + p) != endchar) {
			if (p++ > 128) {
				zmserror("@\"...\"(program set) 's quotaion doesn't seems closed.",linebuf,zms,0,1);
			}
		}
		progname = (char*)emalloc(sizeof(char) * p, "tmp_progname");
		if (endchar == ']') {
			offset = 1;
		}
		strncpy(progname, zms + 1 - offset, p - 1 + offset);
		progname[p - 1 + offset] = '\0';
		zms += p + 1 - offset;

		strlwr(progname);
		cutChar(progname, " -.\t");

		/* for GS modules */
		if (stringReplace(progname,"sc55","55")) {
			module = GS;
		}
		if (stringReplace(progname,"sc88","88")) {
			module = GS;
		}
		if (stringReplace(progname,"sc88pro","8p")) {
			module = GS;
		}
		if (stringReplace(progname,"88pro","8p")) {
			module = GS;
		}
		if (!strncmp(progname,"gs",2)) {
/*		if (stringReplace(progname,"gs","gs");( { */
			module = GS;
		}

		/* for XG modules */
		if (stringReplace(progname,"mu100","xg")) {
			module = XG;
			reallsb = 126;
		}
		if (!strncmp(progname,"xg",2) && progname[strlen(progname) - 1] == '#' ) {
			/* "xg....#" */
			module = XG;
			progname[strlen(progname) - 1] = '\0';
			reallsb = 126;
		}
		if (stringReplace(progname,"xgbasic","xg")) {
			module = XG;
			reallsb = 127;
		}
		if (stringReplace(progname,"mubasic","xg")) {
			module = XG;
			reallsb = 127;
		}
		if (stringReplace(progname,"basic","xg")) {
			module = XG;
			reallsb = 127;
		}

		if (module == -1) {		/* module name is omitted */
			zmserror("@\"...\": module name should be specified.",linebuf,zms,0,1);
		}

createCashTable();

		hash  = calcHash(progname, 0);
		hash2 = calcHash(progname, 1);
/* fprintf(stderr,"[%s] ",progname); */
		do {
/*fprintf(stderr,"[%.4x] ",hash);*/
			tmp = refHash(hashtbl[module], hash);
			if (tmp == (PROGHASH*)NULL) {
				zmserror("@\"...\": program name is not defined.",linebuf,zms,0,1);
/*				zmserror("@\"...\": program name is not defined. (check @i's setting also)",linebuf,zms,0,1);*/
			}
			if (!strcmp(tmp->progname, progname)) {
				break;
			}
			hash += hash2;
		} while (1);

		if (reallsb > 0 && module == XG) {
			tmp->lsb = reallsb;
		}

		b1   = tmp->msb;
		b2   = tmp->lsb;
		tone = tmp->pc;
/*fprintf(stderr,"[%s: %d/%d/%d]\n",progname, b1, b2, tone);*/
/*fprintf(stderr,"[%s  i%d,%d @%d]\n",progname, b1, b2, tone);*/
		cmd = 3;
		efree(progname, "tmp_progname");

/* releaseCashTable(); */


	} else {
		zms = skipSpc(zms);
		if (*zms == ':' && *(zms + 1) != '|') {		/* @n1:n2,n3 */
			cmd = 1;
			b1 = tone;
			zms = getnum2(zms + 1, &b2, &err);
			if (err) {
				b2  = 0xFF;
			}
			zms = skipSpc(zms);
			if (*zms == ',') {
				zms = getnum2(zms + 1, &tone, &err);
				if (err) {
					zmserror("`@'(program set) error.",linebuf,zms,0,1);
				}
			} else {
				zmserror("`@'(program set) error.",linebuf,zms,0,1);
			}
		} else if (*zms == ',') {	/* @n1,n2 */
			cmd = 2;
			b1 = (tone >> 7) & 0x7F;
			b2 = tone & 0x7F;
			zms = getnum2(zms + 1, &tone, &err);
			if (err) {
				zmserror("`@'(program set) error.",linebuf,zms,0,1);
			}
		}
	}


	for (trk = 0; target[trk] >= 0; trk++) {
		const int Trk = target[trk];

		if (cmd) {
			*trkdata[Trk].zmd++ = 0xC6;
			*trkdata[Trk].zmd++ = b1;
			*trkdata[Trk].zmd++ = b2;
		}
		*trkdata[Trk].zmd++ = 0xC7;
		putWord(trkdata[Trk].zmd, tone - 1);
		trkdata[Trk].zmd += 2;
	}

	return zms;
}


UBYTE *makeZmdProgramBankChange(UBYTE *zms, TRKCHINF *trkdata, const BYTE target[])
{
	return makeZmdManyParas(zms,trkdata,target,linebuf,
								0xC6, 0x00, 2, 1, 1,
								"i: too many parameters.",
								"i: can't use relational parameters.",
								"");
}



UBYTE *makeZmdProgramSplitSwitch(UBYTE *zms, TRKCHINF *trkdata, const BYTE target[])
{
	int trk, err;
	DWORD para;
	const char *p[] = {"off", "on", NULL};

	zms = getnum4(zms,&para,&err, p, 0);
	if (!err) {
		for (trk = 0; target[trk] >= 0; trk++) {
			const int Trk = target[trk];
			*trkdata[Trk].zmd++ = 0xDE;
			*trkdata[Trk].zmd++ = 0x80;
			*trkdata[Trk].zmd++ = para;
		}
	} else {
		zmserror("[TIMBRE_SPLIT.SWITCH] require its parameter.",linebuf,zms,4,1);
	}
	return zms;
}

UBYTE *makeZmdProgramSplit(UBYTE *zms, TRKCHINF *trkdata, TRKINF *trkinf,
							COMMONINF *cominf, const BYTE target[])
{
	int trk;
	DWORD line_ = line;
	UBYTE *linebuf_ = linebuf;
	UBYTE *zms_ = zms;
	LINEDATA *ld_ = ld;


	for (trk = 0; target[trk] >= 0; trk++) {
		const int Trk = target[trk];
		const int octbak = trkinf[Trk].octave;
		const char *p[] = {"off","on",NULL};
		DWORD sw = 1;
		int paras = 0, err;
		UBYTE *zmd_;

		linebuf = linebuf_;
		line = line_;
		ld = ld_;

		*trkdata[Trk].zmd++ = 0xDE;
		zmd_ = trkdata[Trk].zmd;
		trkdata[Trk].zmd++;

		zms = getnum4(zms_,&sw,&err, p, 0);
		if (err || sw) {
			sw = 0x80;
		}
		zms = skipSpcCr(zms);
		if (*zms == ',') {
			zms++;
		}
		if (*zms != ']') {

			while (1) {
				int err;
				DWORD b1, b2 = 0, t1;
				BYTE m1, n1;

				linebuf = linebuf_;
				line = line;
				ld = ld_;

				zms = getnum2(zms, &b1, &err);
				if (err) {
					zmserror("[timbre_split] parameter error.",linebuf,zms,0,1);
				}
				zms = skipSpcCr(zms);
				if (*zms == ':') {
					zms = getnum2(zms + 1, &b2, &err);
					if (err) {
						zmserror("[timbre_split] parameter error.",linebuf,zms,0,1);
					}
					b1 <<= 7;
					b1 += b2;
				}
				if (*zms == ',') {
					zms++;
				}
				zms = getnum2(zms, &t1, &err);
				if (*zms == ',') {
					zms++;
				}
				zms = getZmsNoteSub(zms, trkinf, cominf, Trk, &m1);
				if (*zms == ',') {
					zms++;
				}
				zms = getZmsNoteSub(zms, trkinf, cominf, Trk, &n1);

				*trkdata[Trk].zmd++ = m1;
				*trkdata[Trk].zmd++ = n1;
				putWord(trkdata[Trk].zmd, b1);
				trkdata[Trk].zmd += 2;
				putWord(trkdata[Trk].zmd, t1 - 1);
				trkdata[Trk].zmd += 2;

				paras++;
				zms = skipSpcCr(zms);
				if (*zms != ',') {
					break;
				} else {
					zms++;
					if (paras > 8) {
						zmserror("[timbre_split] too many parameters.",linebuf,zms,0,1);
					}
				}
			}
		}
		*zmd_ = sw + paras;
		trkinf[Trk].octave = octbak;
	}
	return zms;
}



UBYTE *getZmsNoteSub(UBYTE *zms, TRKINF *trkinf, COMMONINF *cominf, const int Trk, BYTE *note)
{
	/* int octave_bak = trkinf[Trk].octave; */
	*note = (trkinf[Trk].octave  + 1) * 12;

	while (1) {
		if (*zms == 'o' || *zms == 'O' || *zms == '<' || *zms == '>') {
			zms = checkOctaveChange(zms, trkinf, cominf, Trk);
			*note = (trkinf[Trk].octave  + 1) * 12;
#ifdef AA
		} else if (*zms == '<') {
			*note += 12;
			trkinf[Trk].octave++;
			zms++;
		} else if (*zms == '>') {
			*note -= 12;
			trkinf[Trk].octave--;
			zms++;
#endif
		} else if ('a' <= tolower(*zms) && tolower(*zms) <= 'g') {
			zms = makeZmdNote1(zms,Trk,trkinf,note);

#ifdef AA
			const BYTE tonetbl[7] = { 0, 2, 4, 5, 7, 9, 11 };
			BYTE n = tolower(*zms) - 'a' - 2;

			if (n < 0) {
				n += 7;
			}
			*note += tonetbl[n];
			zms++;
		} else if (*zms == '#' || *zms == '+') {
			note++;
			zms++;
		} else if (*zms == '-') {
			note--;
			zms++;
#endif
		} else if (isspace(*zms)) {
			zms++;
		} else if (isdigit(*zms)) {
			DWORD tmp;
			int err;

			zms = getnum2(zms, &tmp, &err);
			*note = tmp;
		} else {
			break;
		}
	}

	return zms;
}


/* remove "cut" characters */
char *cutChar(char *str, char *cut)
{
	while (*cut) {
		char	*p = str - 1;

		while (*++p) {
			if (*p == *cut) {
				char *p2 = p;
				do {
					*p2 = *(p2 + 1);
				} while (*p2++);
			}
		}
		cut++;
	}
	return str;
}


/* strlen(s1) must be lower than strlen(s2) */
int stringReplace(char *str, const char *s1, const char *s2)
{
	int flg = 0;

	if (!strncmp(str, s1, strlen(s1))) {
		char *p1 = str + strlen(s1) - 1, *p2 = str + strlen(s2) - 1;
		strncpy(str, s2, strlen(s2));
		do {
			*++p2 = *++p1;
		} while (*p1);
		flg = 1;
	}
	return flg;
}

