#ifndef STRUCTS

	#define	FIRST_MTRK_SIZE		8192	/* MTrk reallocs par FIRST_MTRK_SIZE */
	#define	MTRK_OVERFLOW_RANGE	1024	/* MTrk reallocs if memory lasts MTRK_OVERFLOW_RANGE */

	#include "config.h"

	typedef struct {
		BYTE	ch;						/* channel no. (set by @n,etc) */
		BYTE	ch_;					/* channel no. (set by (AMIDI1,1),etc: initial set) */
		UWORD	chtype;					/* FM=0 ADPCM=1 MIDI=$8000-3 PATTERN=$7FFF
											 CURRENTMIDI=$FFFF */

		UBYTE	trkv;					/* track volume (0 - 128) */
		UBYTE	trkf;					/* freq (1 - 256) */
		UBYTE	trks;					/* PLAY(0) / RECORD(1) */
		UBYTE	trkm;					/* NORMAL(0) / RHYTHM(1) */

		UBYTE	mute;					/* mute(0) / play(1) */

		char	*cmnt;					/* comment */

		UBYTE	*zmd;					/* ZMDdata pointer */
		UBYTE	*zmdbuf;				/* ZMDdata buffer address */
		DWORD	buforgsize;				/* original buffer size, set in (Mx,xxxx) */
		DWORD	bufsize;				/* buffer size */
		DWORD	nowsize;				/* buffer size used now */
		DWORD	total;					/* total steps (w/o loop) */
		DWORD	backinuse;				/* NOUSE==-1, USE=backtrk */
	} TRKCHINF;


	typedef struct {
		DWORD	div;					/* default timebase */
		DWORD	div2;					/* -1: default  0...: real timebase */
		WORD	tempo;
		BYTE	basech;
		BYTE	debug;
		BYTE	trkassign[80 + 1];
		BYTE	backtrk[80 + 1];		/* track which will be used for [back ...] */
		BYTE	fromtrk[80 + 1];		/* return track from [back...] */
		BYTE	l1tie;
		BYTE	renpmode;				/* 1 or 2: 1/2byte step/gate mode */
		DWORD	maxtrk;					
		UBYTE	fmvol;					/* fm_master_volume */
		UBYTE	adpcmbank;				/* adpcm_bank */
		BYTE	opmtone[55];			/* fm tone data */
		BYTE	polpcm;					/* pcm8 track */

		BYTE	qmode;					/* quantize_mode */
		WORD	gtreso;					/* gatetime_resolution */
		BYTE	relativevelomode;		/* .relative_velocity */
		BYTE	lengthmode;				/* .length_mode */

		DWORD	cmnt;					/* comment start address(offset) */
		UWORD	meter;					/* meter: nnmm */
		BYTE	key;					/* key */
		BYTE	majorflag;				/* 0: major 1: minor */
		BYTE	currentmidiin;
		BYTE	currentmidiout;

		BYTE	trackmode;				/* 1: .TRACK  0: (Tn) */
		BYTE	octavemode;				/* 0: <:up  1: >:up */

		DWORD	z_cmn_flag;				/* which common trk command was used? */
		int		backinuse;				/* [back..] is used in some track */
	} COMMONINF;




	#define STRUCTS
#endif	/* STRUCTS */
